scmTimestamps = {}

SCM_TIMESTAMP_FORMAT = "%H:%M"
SCM_TIMESTAMP_COLOR = "777777"
SCM_TIMESTAMP_OUTPUT_FORMAT = "%s|r %s"
SCM_TIMESTAMP_ACTIVE = {
	true, --[1]
	true, --[2]
	true, --[3]
	true, --[4]
	true, --[5]
	true, --[6]
	true  --[7]
}

local _G = getfenv(0)
local format = nil
local orig = {}

local function addMessage(frame, text, ...)
	if type(text) == "string" then
		text = format:format(date(SCM_TIMESTAMP_FORMAT), text)
	end
	return orig[frame](frame, text, ...)
end

function scmTimestamps:Enable()
	self:UpdateFormat()

	for i = 1, NUM_CHAT_WINDOWS do
		if SCM_TIMESTAMP_ACTIVE[i] then
			local c = _G["ChatFrame"..i]
			orig[c] = c.AddMessage
			c.AddMessage = addMessage
		end
	end
end

function scmTimestamps:Disable()
	for i = 1, NUM_CHAT_WINDOWS do
		local c = _G["ChatFrame"..i]
		if orig[c] then
			c.AddMessage = orig[c]
		end
	end
end

function scmTimestamps:Update()
	self:Disable()
	self:Enable()
end

function scmTimestamps:UpdateFormat()
	format = "|cff"..SCM_TIMESTAMP_COLOR..SCM_TIMESTAMP_OUTPUT_FORMAT
end

scmTimestamps:Enable()

